#!/usr/bin/env node

// Generated by LiveScript 1.3.1
var fs, path, lib, updater, say, mvn, dbdeploy, i$, ref$, len$, cmd, main, getAvailable, getLatest, getCurrent, setCurrent;
fs = require('fs');
path = require('path');
lib = path.join(path.dirname(fs.realpathSync(__filename)), '../lib');
updater = require(lib + "/updater");
say = console.log;
mvn = '/opt/apache-maven-3.1.1/bin/mvn';
dbdeploy = '/Users/ozchaz/Scripts/dbdeploy';
if (mvn.length === 0 || dbdeploy.length === 0) {
  if (mvn.length === 0) {
    say("cannot find mvn");
  }
  if (dbdeploy.length === 0) {
    say("cannot find dbdeploy");
  }
  process.exit(1);
}
if (process.argv.length < 3) {
  say(path.basename(process.argv[1]) + " command");
  say("known commands are:");
  for (i$ = 0, len$ = (ref$ = ['get-available', 'get-latest', 'get-current', 'set-current']).length; i$ < len$; ++i$) {
    cmd = ref$[i$];
    say("  " + cmd);
  }
  process.exit(1);
}
main = function(){
  var cmd;
  cmd = process.argv[2];
  switch (cmd) {
  case 'get-available':
    getAvailable();
    break;
  case 'get-latest':
    getLatest();
    break;
  case 'get-current':
    getCurrent();
    break;
  case 'set-current':
    setCurrent(process.argv[3]);
    break;
  default:
    say("unknown command " + cmd);
  }
};
getAvailable = function(){
  updater.getAvailable(function(err, avail){
    var i$, len$, a;
    if (err != null) {
      return console.warn(err);
    }
    for (i$ = 0, len$ = avail.length; i$ < len$; ++i$) {
      a = avail[i$];
      console.log(a);
    }
  });
};
getLatest = function(){
  updater.getLatest(function(err, latest){
    if (err != null) {
      return console.warn(err);
    }
    console.log(latest);
  });
};
getCurrent = function(){
  updater.getCurrent(function(err, current){
    if (err != null) {
      return console.warn(err);
    }
    console.log(current);
  });
};
setCurrent = function(version){
  var pa1;
  if (version == null) {
    pa1 = path.basename(process.argv[1]);
    say("usage: " + pa1 + " set-current <version>");
    say("   ex: " + pa1 + " set-current 1.16.10");
    return;
  }
  updater.setCurrent(version, function(err){
    if (err != null) {
      return console.warn(err);
    } else {
      return console.log("version set to " + version);
    }
  });
};
main();