// Generated by LiveScript 1.3.1
(function(){
  var fs, async, http, xml2js, child, pl, webapps, mvn, dbdeploy, startup, shutdown, basepath, doexec, withMavenMeta, downloadElementsPick, downloadElements;
  fs = require('fs');
  async = require('async');
  http = require('http');
  xml2js = require('xml2js');
  child = require('child_process');
  pl = require('prelude-ls');
  webapps = '/opt/tomcat/webapps';
  mvn = '/opt/maven/bin/mvn';
  dbdeploy = '/Users/charlieozinga/Scripts/dbdeploy';
  startup = '/opt/tomcat/bin/startup.sh';
  shutdown = '/opt/tomcat/bin/shutdown.sh';
  basepath = '/cloudelements/elements-application-elements';
  doexec = function(cmd, ecb, cb){
    var proc;
    proc = child.exec(cmd, {
      env: process.env
    }, function(error, stdout, stderr){
      if (stdout != null && stdout.length) {
        console.log(cmd + " stdout: " + stdout);
      }
      if (stderr != null && stderr.length) {
        console.log(cmd + " stderr: " + stderr);
      }
      if (error != null) {
        return console.log(cmd + " error: " + error);
      }
    });
    proc.on('exit', function(code, sig){
      if (sig != null) {
        ecb(cmd + " signal: " + sig);
      } else if (code !== 0) {
        ecb(cmd + " code: " + code);
      } else {
        cb();
      }
    });
  };
  withMavenMeta = function(path, cb){
    var process, client;
    process = function(data){
      xml2js.parseString(data, function(err, jsmeta){
        return cb(null, jsmeta);
      });
    };
    client = http.request({
      hostname: 'repo.cloud-elements.com',
      port: 80,
      path: path,
      method: 'GET'
    }, function(response){
      var data;
      data = '';
      response.setEncoding('utf8');
      response.on('readable', function(){
        return data += response.read();
      });
      response.on('error', cb);
      return response.on('end', function(){
        return process(data);
      });
    });
    client.on('error', cb);
    client.end();
  };
  downloadElementsPick = function(version, cb){
    withMavenMeta(basepath + ("/" + version + "/maven-metadata.xml"), function(err, jsmeta){
      return cb(err, jsmeta != null ? jsmeta.metadata.versioning[0].snapshotVersions[0].snapshotVersion[0].value : void 8);
    });
  };
  downloadElements = function(version, cb){
    var downloadWith;
    downloadWith = function(vers){
      return doexec("rm -rf " + webapps + "/elements", cb, function(err){
        if (err != null) {
          return cb(err);
        }
        return doexec("rm -f " + webapps + "/elements.war", cb, function(err){
          var local, dfile, client;
          if (err != null) {
            return cb(err);
          }
          local = webapps + '/elements.war';
          dfile = fs.createWriteStream(local);
          client = http.request({
            hostname: 'repo.cloud-elements.com',
            port: 80,
            path: basepath + ("/" + version + "/elements-application-elements-" + vers + ".war"),
            method: 'GET'
          }, function(response){
            if (response.statusCode !== 200) {
              return cb("couldn't download " + version + ": " + response.statusCode);
            } else {
              response.pipe(dfile);
              return dfile.on('finish', function(){
                dfile.close(cb);
              });
            }
          });
          client.on('error', function(err){
            fs.unlink(local);
            cb(err);
          });
          return client.end();
        });
      });
    };
    if (version.indexOf('SNAPSHOT') !== -1) {
      downloadElementsPick(version, function(err, vers){
        if (err != null) {
          return cb(err);
        }
        console.log("using vers " + vers);
        return downloadWith(vers);
      });
    } else {
      downloadWith(version);
    }
  };
  exports.getAvailable = function(cb){
    withMavenMeta(basepath + '/maven-metadata.xml', function(err, jsmeta){
      return cb(err, jsmeta != null ? jsmeta.metadata.versioning[0].versions[0].version : void 8);
    });
  };
  exports.getLatest = function(cb){
    withMavenMeta(basepath + '/maven-metadata.xml', function(err, jsmeta){
      return cb(err, jsmeta != null ? jsmeta.metadata.versioning[0].release[0] : void 8);
    });
  };
  exports.getCurrent = function(cb){
    var mf;
    mf = webapps + "/elements/META-INF/MANIFEST.MF";
    fs.readFile(mf, {
      encoding: 'utf8'
    }, function(err, data){
      var i$, ref$, len$, line, version;
      if (err != null) {
        return cb(err);
      }
      for (i$ = 0, len$ = (ref$ = data.split('\n')).length; i$ < len$; ++i$) {
        line = ref$[i$];
        if (line.indexOf('version: ') === 0) {
          version = line.substring(9).trim();
          break;
        }
      }
      if (version != null) {
        return cb(null, version);
      } else {
        return cb("can't read version from " + mf);
      }
    });
  };
  exports.setCurrent = function(version, cb){
    console.log("shutting down tomcat...");
    doexec(shutdown, cb, function(){
      return setTimeout(function(){
        console.log("updating WAR resource...");
        return downloadElements(version, function(err){
          if (err != null) {
            return cb(err);
          }
          console.log("updating database...");
          return doexec(dbdeploy, cb, function(){
            console.log("restarting tomcat...");
            return doexec(startup, cb, function(){});
          });
        });
      }, 4000);
    });
  };
}).call(this);
