require! express
require! 'cookie-parser'
require! 'express-session'
require! 'body-parser'
require! './routes'

allow-cross-domain = (req, res, next) ->
  res.header 'Access-Control-Allow-Credentials', true
  res.header 'Access-Control-Allow-Origin', req.headers?origin ? '*'
  res.header 'Access-Control-Allow-Methods', 'PUT,OPTIONS,GET,DELETE,POST'
  res.header 'Access-Control-Allow-Headers', 
      req.headers?['Access-Control-Request-Headers'] ?
      'x-requested-with,content-type,authorization,accept'
  res.header 'Access-Control-Max-Age', 1728000
  next!

app = express!

app.use allow-cross-domain
app.use cookie-parser 'alfa3982312ndk3'
app.use express-session resave: true, save-uninitialized: true, secret: 'abcde'
app.use body-parser.json!

# put something in the body to let cross-domain happen
app.options \*, (req, res, next) !-> res.send 200

app.get '/available', routes.available
app.get '/latest', routes.latest
app.get '/current', routes.current
app.get '/status', (req, res) !-> res.send status: "It's all good, man"
app.put '/current', routes.put-current

app.listen 3030
console.log 'Listening on 3030'

