#!/usr/bin/env lsc

# updater-bin.js Copyright (c) 2013 Cloud Elements. All rights reserved.
# CLOUD-ELEMENTS PROPRIETARY / CONFIDENTIAL. Use is subject to license
# terms.
# 
# Created on 1/11/14 by Charlie Ozinga.

require! fs
require! path
lib = path.join path.dirname(fs.realpath-sync __filename), '../lib'
updater = require "#lib/updater"

say = console.log
mvn = '/opt/apache-maven-3.1.1/bin/mvn'
dbdeploy = '/Users/ozchaz/Scripts/dbdeploy'

if mvn.length == 0 or dbdeploy.length == 0
  if mvn.length == 0
    say "cannot find mvn"
  if dbdeploy.length == 0
    say "cannot find dbdeploy"
  process.exit 1

if process.argv.length < 3
  say "#{path.basename process.argv.1} command"
  say "known commands are:"
  for cmd in <[get-available get-latest get-current set-current]>
    say "  #cmd"
  process.exit 1

main = !->
  cmd = process.argv.2
  switch cmd
    | \get-available => get-available!
    | \get-latest => get-latest!
    | \get-current => get-current!
    | \set-current => set-current process.argv.3
    | _ => say "unknown command #cmd"

get-available = !->
  updater.get-available (err, avail) !->
    return console.warn err if err?
    for a in avail
      console.log a

get-latest = !->
  updater.get-latest (err, latest) !->
    return console.warn err if err?
    console.log latest

get-current = !->
  updater.get-current (err, current) !->
    return console.warn err if err?
    console.log current

set-current = (version) !->
  if !version?
    pa1 = path.basename process.argv.1
    say "usage: #pa1 set-current <version>"
    say "   ex: #pa1 set-current 1.16.10"
    return

  updater.set-current version, (err) ->
    if err? then console.warn err
    else console.log "version set to #version"

main!
